;   OS FD-IPLware  BOOTLOADER (C) 2023 ܂
;   IPL   CS:IP 1FC0:0000 Ƀ[h.
;   i[  CS:IP 7400:0000 Ƀ[hs.

L_COLUMN        equ     24      ; \Jʒui[O`j
L_ROW           equ     19      ; \sʒui[Q`QQj
XCHG_ROW        equ     23      ; 
FD_DATA_SEG     equ     7400h   ; disk read data
OPE_MANUAL      equ     01h
OPE_CANCEL      equ     02h
OPE_NOEXEC      equ     20h

Palette         macro   P_NUM,P_GREEN,P_RED,P_BLUE
                mov     al,P_NUM
                out     0A8h,al
                mov     al,P_GREEN
                out     0AAh,al
                mov     al,P_RED
                shl     al,1
                mov     ah,al
                out     0ACh,al
                mov     al,P_BLUE
                mov     al,12
                sub     al,ah
                out     0AEh,al
endm

.8086
code            segment
                assume cs:code, ds:code, es:code, ss:code
        ORG   0h
start:          JMP     CodeStart
;BiosParameterBlock
 DB            90h, 4Eh, 45h, 43h, 20h, 20h, 35h, 2Eh, 30h, 00h, 04h, 01h, 01h, 00h
 DB  02h,0C0h, 00h,0D0h, 04h,0FEh, 02h, 00h, 08h, 00h, 02h, 00h, 00h, 00h, 00h, 00h
 DB  00h, 00h, 00h, 00h, 80h, 00h, 29h, 15h, 09h, 23h, 20h, 46h, 44h, 2Dh, 49h, 50h
 DB  4Ch, 57h, 41h, 52h, 45h, 20h, 46h, 41h, 54h, 31h, 32h, 20h, 20h, 20h
        ORG   3Eh
CodeStart:
; ɗ܂ł͂Ԃ CS=1FC0h, DS=0000h, SS=2000h, SP=FF??h
                push    ax
                push    bx
                push    cx
                push    dx
                push    si
                push    di
                push    es
                push    ds

                push    cs      ; DS=CS ɍ킹
                pop     ds      ; 

                call    InitDisplay

                xor     ax,ax
                mov     es,ax
                mov     al,es:[0584h]
                mov     BootDAUA,al

BootDevOK:
                mov     si,offset MsgLoading
                mov     es,SegTVRAM
                mov     dl,0E5h    ; \FAgr[g
                mov     di, ( (XCHG_ROW-1)*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,( offset MsgLoading_E - offset MsgLoading )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

; V_ 77,0   S̃f[^ǂݍ  7400:048KB
                call    LoadCyl77_48KB

                test    DiskError,7
                jz      DiskNoErr
                mov     dl,045h    ; \FAgr[g
                mov     si,offset MsgDiskErr
                mov     es,SegTVRAM
                mov     di, (L_ROW*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,( offset MsgDiskErr_E - offset MsgDiskErr )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b
                call    LongBeep
                JMP     BootFromOther
DiskNoErr: 
                mov     si,offset MsgScanning
                mov     es,SegTVRAM
                mov     dl,0E5h    ; \FAgr[g
                mov     di, ( (XCHG_ROW-1)*80+L_COLUMN+21)*2        ; 12L,14C
                mov     cx,( offset MsgScanning_E - offset MsgScanning )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

ifdef   NOJMP_TEST
                mov     al,0CBh
                mov     es,SegDataFD
                mov     es:[0],al
endif
                call    wait1s
                xor     ax,ax
                out     0A8h,al
                out     0AAh,al
                out     0ACh,al
                out     0AEh,al

;L[`FbN ---
                in      al,41h  ; Status check 𖳎ăL[{[hǂ
                and     al,7Fh  ; make/break ꎋ
                cmp     al,39h  ; [DEL]Ȃ SpX
                je      CancelMode
                cmp     al,3Fh  ; [HELP] Ȃ ₢킹ɐݒ
                jne     EndOfKeyCheck
InqMode:        or      OpeMode,OPE_MANUAL
                jmp     EndOfKeyCheck
CancelMode:     or      OpeMode,OPE_CANCEL
EndOfKeyCheck:
                mov     ah,3
                int     18h
                mov     es,SegDataFD
                mov     al,OpeMode
                mov     es:[000Ah],al   ; OpeMode

                mov     al,es:[0000h]
                cmp     al,0EAh
                je      IsJumpCode
                cmp     al,0EBh
                je      IsJumpCode
                cmp     al,0E8h
                je      IsJumpCode
                cmp     al,0E9h
                je      IsJumpCode
                jmp     BootFromOther
IsJumpCode:
                DB      9Ah     ; call far
                DW      0000h
SegDataFD       DW      FD_DATA_SEG

BootFromOther:  ;FDbZ[Ws\
                
                mov     al,25h
                call    ClrAttrArea;
                
                mov     si,offset MsgExchangeFD
                mov     dl,0C3h    ; \FAgr[g
                mov     di, ( XCHG_ROW*80+2)*2        ; 22L,10C
                mov     cx,( offset MsgExchangeFD_E - offset MsgExchangeFD )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

                mov     si,offset MsgIfRemoveFD
                mov     dl,025h    ; \FAgr[g
                mov     di, ( (1+XCHG_ROW)*80+16)*2        ; 22L,10C
                mov     cx,( offset MsgIfRemoveFD_E - offset MsgIfRemoveFD )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

                call    ShortBeep
                xor     ax,ax
                int 18h
                
                cld
                mov     es,SegDataFD
                xor     ax,ax
                mov     di,ax
                mov     cx,0C000h/2
       rep      stosw

                mov     dx,0E120h
                mov     ah,16h
                int     18h

                pop     ds      ; ***
                pop     es
                pop     di
                pop     si
                pop     dx
                pop     cx
                pop     bx
                pop     ax
                RETF            ; dummy (may not executed)

SegTVRAM        DW      0A000h
OpeMode         DB      0
BootDAUA        DB      90h
;=======================================

;---------------------------------------
;include E:\fdiplw2\fdiplsub.s
;---------------------------------------
;---------------------------------------
ShortBeep:      mov     cx,2000h
                jmp     Beep00

LongBeep        PROC   near
                mov     cx,0F000h
Beep00:
                push    ax
                mov     al,6h
                out     37h,al
          @@:   out     5Fh,al
                out     5Fh,al
               loop     @b
                mov     al,7h
                out     37h,al
                pop     ax
                ret
LongBeep        ENDP
;---------------------------------------
wait1s          PROC   near
                push    ax
                push    cx
                mov     cx,0FEDCh
          @@:   out     5Fh,al
                out     5Fh,al
                out     5Fh,al
                out     5Fh,al
               loop     @b
                pop     cx
                pop     ax
                ret
wait1s          ENDP
;---------------------------------------
ClrAttrArea     PROC   near     ; input al=attribute code
                cld
                mov     es,SegTVRAM
                mov     di,(XCHG_ROW-1)*80*2
                mov     cx,80*3
                mov     dl,al
                mov     ax,0020h
         @@:    
                mov     es:[di+2000h],dl
                stosw
               loop @b
                ret
ClrAttrArea     ENDP
;---------------------------------------
;       InitDisplay
;---------------------------------------
InitDisplay     PROC   near
                xor     ax,ax
                mov     es,ax
                mov     al,es:[0501h]    ; nC]`FbN
                test    al,8
                jz      @f     ; nC]̂Ƃ
                mov     SegTVRAM,0E000h ; VRAMZOgύX
                jmp     BothResolution
        @@:
                mov     al,01h
                out     06Ah,al ; CRTC ON
                mov     al,08h
                out     068h,al ; 400 line
BothResolution:
                mov     al,0Dh  ; GRAPHIC \Iɂ
                out     0A2h,al
                ret
InitDisplay     ENDP


;------------------------------------
; LoadCyl77_48KB read floppy directly
;------------------------------------
LoadCyl77_48KB  PROC   near
                mov     ax,FD_DATA_SEG
                mov     es,ax
                mov     si,offset CHRN_base
                mov     bp,0000h
                mov     cx,6            ; 6 blocks
load_CHRN_base: mov     bx,8192         ; len=8KB
                push    cx
                mov     cx,[si]
                inc     si
                inc     si
                mov     dx,[si]
                inc     si
                inc     si
                mov     ah,56h          ; no retry, seek
                mov     al,cs:BootDAUA
                and     al,00000011b
                or      al,10010000b    ; bit of [1M],[FDD]
                int     1Bh
                jnc     NoDiskError
                inc     DiskError       ; error counter
NoDiskError:    pop     cx
                add     BP,8192 ; adrv 8KB
                Palette 0,0,CL,CL
               loop     load_CHRN_base
                mov     ax,es:[0]
                cmp     ax,0E5E5h       ; clean formatted
                jne     @f
                mov     DiskError,7     ; 7 means data error (unrecorded)
        @@:     
                ret
;  ItZbg     CH3 CLV_  DHwbhDLZN^
;    BX=8192,     CX      DX     BlockSize
CHRN_base       label   word
        DW      034Dh,  0001h  ; 1
        DW      034Dh,  0101h  ; 2
        DW      034Eh,  0001h  ; 3
        DW      034Eh,  0101h  ; 4
        DW      034Fh,  0001h  ; 5
        DW      034Fh,  0101h  ; 6
DiskError       DB      00h
LoadCyl77_48KB  ENDP
;------------------------------------

MsgLoading       label   byte
;uFD-IPLwareع ۰ޒv
  DW  0,0046h,0044h,002Dh,0049h,0050h,004Ch,0077h,0061h,0072h,0065h,00B1h
  DW  00CCh,00DFh,00D8h,00B9h,00B0h,00BCh,00AEh,00DDh,0020h,00DBh,00B0h,00C4h
  DW  00DEh,6623h,66A3h,0020h
MsgLoading_E     label   byte

;;;u݁v
MsgScanning       label   byte
  DW  00BDh,00B7h,00ACh,00DDh
MsgScanning_E     label   byte


;;;ufBXNǂݎ̏Q܂v
MsgDiskErr      label   byte
  DW  4705h,4785h,2305h,2385h,3905h,3985h,2F05h,2F85h,4926h,49A6h,5F04h
  DW  5F84h,681Ch,689Ch,6A04h,6A84h,4E04h,4E84h,631Eh,639Eh,3213h,3293h
  DW  2C04h,2C84h,2F28h,2FA8h,3820h,38A0h,3704h,3784h,5E04h,5E84h,3704h
  DW  3784h,3F04h,3F84h
MsgDiskErr_E    label   byte



MsgExchangeFD label byte
;;;u[_ɖ߂܂Bec𔲂ւĂdmsdqL[ĉBv
  DW  6D05h,6D85h,3C01h,3C81h,4005h,4085h,4B04h,4B84h,612Ch,61ACh,6A04h
  DW  6A84h,5E04h,5E84h,3704h,3784h,3F04h,3F84h,2301h,2381h,4603h,4683h
  DW  4403h,4483h,7204h,7284h,3428h,34A8h,2F04h,2F84h,2B04h,2B84h,391Ah
  DW  399Ah,3704h,3784h,5822h,58A2h,2804h,2884h,4604h,4684h,4503h,4583h
  DW  4E03h,4E83h,5403h,5483h,4503h,4583h,5203h,5283h,2D05h,2D85h,3C01h
  DW  3C81h,7204h,7284h,2112h,2192h,3704h,3784h,4604h,4684h,3C12h,3C92h
  DW  3504h,3584h,2404h,2484h,2301h,2381h
MsgExchangeFD_E label byte

MsgIfRemoveFD label byte
;;;ufBA𔲂ĂL[ƂgcNv
  DW  6105h,6185h,4705h,4785h,2305h,2385h,2205h,2285h,7204h,7284h,3428h,34A8h
  DW  2404h,2484h,4604h,4684h,2B04h,2B84h,6904h,6984h,2D05h,2D85h,3C01h,3C81h
  DW  7204h,7284h,2112h,2192h,3904h,3984h,4804h,4884h,4803h,4883h,4403h,4483h
  DW  2B04h,2B84h,6904h,6984h,2F15h,2F95h,3026h,30A6h,0020h
MsgIfRemoveFD_E label byte

org     768-1
CHKSUM  DB      0FFh

org     1024-2
DW      0
;-------------ȍ~ɋLqĂ͂ȂȂ------------
code    ends
        end start
END
