;   OS FD-IPLware  BOOTLOADER for 1.44MB FD  (C) 2023 ܂
;   IPL   CS:IP 1FE0:0000 Ƀ[h.
;   i[  CS:IP 7400:0000 Ƀ[hs.

L_COLUMN        equ     24      ; \Jʒui[O`j
L_ROW           equ     19      ; \sʒui[Q`QQj
XCHG_ROW        equ     23      ; 
FD_DATA_SEG     equ     7400h   ; disk read data

Palette         macro   P_NUM,P_GREEN,P_RED,P_BLUE
                mov     al,P_NUM
                out     0A8h,al
                mov     al,P_GREEN
                out     0AAh,al
                mov     al,P_RED
                shl     al,1
                mov     ah,al
                out     0ACh,al
                mov     al,P_BLUE
                mov     al,12
                sub     al,ah
                out     0AEh,al
endm

.8086
code            segment
                assume cs:code, ds:code, es:code, ss:code
        ORG   0h
start:          JMP     CodeStart
;BiosParameterBlock
 DB            90h, 4Eh, 45h, 43h, 20h, 20h, 35h, 2Eh, 30h, 00h, 02h, 01h, 01h, 00h
 DB  02h,0E0h, 00h, 40h, 0Bh,0F0h, 09h, 00h, 12h, 00h, 02h, 00h, 00h, 00h, 00h, 00h
 DB  00h, 00h, 00h, 00h, 00h, 00h, 29h, 15h, 09h, 23h, 20h, 46h, 44h, 2Dh, 49h, 50h
 DB  4Ch, 57h, 41h, 52h, 45h, 20h, 46h, 41h, 54h, 31h, 32h, 20h, 20h, 20h

        ORG   3Eh
CodeStart:
; ɗ܂ł͂Ԃ CS=1FE0h, DS=0000h, SS=2000h, SP=FF??h
                push    ax
                push    bx
                push    cx
                push    dx
                push    si
                push    di
                push    es
                push    ds

                push    cs      ; DS=CS ɍ킹
                pop     ds      ; 

                xor     ax,ax
                mov     es,ax
                mov     al,es:[0501h]    ; nC]`FbN
                test    al,8
                jz      @f     ; nC]̂Ƃ
                mov     SegTVRAM,0E000h ; VRAMZOgύX
                jmp     BothResolution
        @@:
                mov     al,01h
                out     06Ah,al ; CRTC ON
                mov     al,08h
                out     068h,al ; 400 line
BothResolution:
                mov     al,0Dh  ; GRAPHIC \Iɂ
                out     0A2h,al

                mov     al,es:[0584h]   ; ES=0000h
                mov     byte ptr BootDAUA,al
BootDevOK:
                mov     si,offset MsgLoading
                mov     es,SegTVRAM
                mov     dl,0E5h    ; \FAgr[g
                mov     di, ( (XCHG_ROW-1)*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,( offset MsgLoading_E - offset MsgLoading )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

; V_ 77,0   S̃f[^ǂݍ  7400:048KB
                call    LoadCyl77_45KB

                test    DiskError,7
                jz      DiskNoErr
                mov     dl,045h    ; \FAgr[g
                mov     si,offset MsgDiskErr
                mov     es,SegTVRAM
                mov     di, (L_ROW*80+L_COLUMN)*2        ; 12L,14C
                mov     cx,( offset MsgDiskErr_E - offset MsgDiskErr )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b
                call    LongBeep
                JMP     BootFromOther
DiskNoErr: 
                mov     si,offset MsgScanning
                mov     es,SegTVRAM
                mov     dl,0E5h    ; \FAgr[g
                mov     di, ( (XCHG_ROW-1)*80+L_COLUMN+21)*2        ; 12L,14C
                mov     cx,( offset MsgScanning_E - offset MsgScanning )/2
        @@:     mov     es:[di+2000h],dl
                movsw
               loop     @b

                mov     es,SegDataFD    ; ̍s폜Ȃ悤

;                mov     al,OpeMode
;                mov     es:[000Ah],al   ; OpeMode

                mov     al,es:[0000h]
                cmp     al,0EAh
                je      IsJumpCode
                cmp     al,0EBh
                je      IsJumpCode
;;              cmp     al,0E8h
;;              je      IsJumpCode
                cmp     al,0E9h
                je      IsJumpCode
                jmp     BootFromOther
IsJumpCode:
                DB      9Ah     ; call far
                DW      0000h
SegDataFD       DW      FD_DATA_SEG

BootFromOther:  ;FDbZ[Ws\
                
                call    ShortBeep
                xor     ax,ax
                int 18h
if 0
                mov     es,SegDataFD
                xor     ax,ax
                mov     di,ax
                mov     cx,0B400h/2
       rep      stosw
                mov     dx,0E120h
                mov     ah,16h
                int     18h
endif
                pop     ds      ; ***
                pop     es
                pop     di
                pop     si
                pop     dx
                pop     cx
                pop     bx
                pop     ax
                RETF            ; dummy (may not executed)

SegTVRAM        DW      0A000h
BootDAUA        DB      0

;=======================================

;---------------------------------------
;---------------------------------------
ShortBeep:      mov     cx,2000h
                jmp     Beep00

LongBeep        PROC   near
                mov     cx,0F000h
Beep00:
;                push    ax
                mov     al,6h
                out     37h,al
                out     5Fh,al
               loop     @b
                mov     al,7h
                out     37h,al
;                pop     ax
                ret
LongBeep        ENDP


;------------------------------------
; LoadCyl77_45KB read floppy directly
;------------------------------------
LoadCyl77_45KB  PROC   near
                mov     ax,FD_DATA_SEG
                mov     es,ax
                mov     si,offset CHRN_base
                mov     bp,0000h
                mov     cx,5            ; 5 blocks
load_CHRN_base: mov     bx,9216         ; len=9216Byte
                push    cx
                mov     cx,[si]
                inc     si
                inc     si
                mov     dx,[si]
                inc     si
                inc     si
                mov     ah,56h          ; no retry, seek
                mov     al,cs:BootDAUA
                and     al,00000011b
                or      al,00110000b    ; bit of [1.44M],[FDD] 30h
                int     1Bh
                jnc     NoDiskError
                inc     DiskError       ; error counter
NoDiskError:    pop     cx
                add     BP,9216 ; adrv 9216B
                Palette 0,0,CL,CL
               loop     load_CHRN_base
                mov     ax,es:[0]
                cmp     ax,0E5E5h       ; clean formatted
                jne     @f
                mov     DiskError,7     ; 7 means data error (unrecorded)
        @@:     
                ret
;  ItZbg     CH3 CLV_  DHwbhDLZN^
;    BX=9216,     CX      DX     BlockSize
CHRN_base       label   word
        DW      024Dh,  0101h  ; 1
        DW      024Eh,  0001h  ; 2
        DW      024Eh,  0101h  ; 3
        DW      024Fh,  0001h  ; 4
        DW      024Fh,  0101h  ; 5

DiskError       DB      00h
LoadCyl77_45KB  ENDP
;------------------------------------

MsgLoading       label   byte
;uFD-IPLwareع ۰ޒv
  DW  0,0046h,0044h,002Dh,0049h,0050h,004Ch,0077h,0061h,0072h,0065h,00B1h
  DW  00CCh,00DFh,00D8h,00B9h,00B0h,00BCh,00AEh,00DDh,0020h,00DBh,00B0h,00C4h
  DW  00DEh,6623h,66A3h,0020h
MsgLoading_E     label   byte

;;;u݁v
MsgScanning       label   byte
  DW  00BDh,00B7h,00ACh,00DDh
MsgScanning_E     label   byte

MsgDiskErr      label   byte
;;;ufBXNǂݎ̏Q܂v
  DW  4705h,4785h,2305h,2385h,3905h,3985h,2F05h,2F85h,4926h,49A6h,5F04h
  DW  5F84h,681Ch,689Ch,6A04h,6A84h,4E04h,4E84h,631Eh,639Eh,3213h,3293h
  DW  2C04h,2C84h,2F28h,2FA8h,3820h,38A0h,3704h,3784h,5E04h,5E84h,3704h
  DW  3784h,3F04h,3F84h
MsgDiskErr_E    label   byte

if 0
  DW  4705h,4785h,2305h,2385h,3905h,3985h,2F05h,2F85h,2805h,2885h,6905h
  DW  6985h,3C01h,3C81h,2C04h,2C84h,2F28h,2FA8h,3820h,38A0h,3704h,3784h
  DW  5E04h,5E84h,3704h,3784h,3F04h,3F84h
;;;ufBXNANZXŃG[܂v
  DW  4705h,4785h,2305h,2385h,3905h,3985h,2F05h,2F85h,2205h,2285h,2F05h
  DW  2F85h,3B05h,3B85h,3905h,3985h,4704h,4784h,2805h,2885h,6905h,6985h
  DW  3C01h,3C81h,2C04h,2C84h,2F28h,2FA8h,3820h,38A0h,3704h,3784h,5E04h
  DW  5E84h,3704h,3784h,3F04h,3F84h
endif

org     512-1
OpeMode         DB      0
;-------------ȍ~ɋLqĂ͂ȂȂ------------
code    ends
        end start
END
